Description
Hello,

Since I've updated to Foreman 1.10.1, creating a compute resource using the API produces this error:
"error": {"message":"ERF42-1330 [Foreman::Exception]: must provide a provider"}

Log:

# curl -L -k -u user:password —-H Content-Type:application/json —-H Accept:application/json,version=
2 -X POST http://foreman/api/compute_resources/ -d '{ "compute_resource": { "name": "Openstack",
"provider": "Openstack", "user": "admin", "password": "changeme", "url": "http://1.2.3.4:5000/v2.0
/tokens", "tenant": "admin", "description": "test" }}' -vvv

* About to connect () to foreman port 80 (#0)

&3 Trying foreman... connected

* Connected to foreman (1.2.3.3) port 80 (#0)

Server auth using Basic with user 'user'

POST /api/compute_resources/ HTTP/1.1

Authorization: Basic YXBpYWRtaW46YTEzaUFEbUlOUGE1NVcwcmQ=

User—-Agent: curl/7.19.7 (x86_64-redhat-linux—-gnu) libcurl/7.19.7 NSS/3.15.3 z1ib/1.2.3 libidn/1.
8 libssh2/1.4.2

Host: 1.2.3.3

Content-Type:application/json

Accept:application/json, version=2

Content-Length: 221

*

HTTP/1.1 301 Moved Permanently

Date: Mon, 15 Feb 2016 15:29:15 GMT

Server: Apache/2.2.15 (Red Hat)
Apipie—-Checksum: 471e67ed3baf2103277866dad41f4c006
X-UA-Compatible: IE=Edge,chrome=1
Cache-Control: no-cache

X-Request-Id: 076£82c9004ce38b87£420066ec8a558
X-Runtime: 0.011892

X-Rack-Cache: invalidate, pass

X-Powered-By: Phusion Passenger 4.0.18
Set-Cookie: request_method=POST; path=/
Location: https://foreman/api/compute_resources
Status: 301 Moved Permanently

Vary: Accept-Encoding

Connection: close

Transfer-Encoding: chunked

Content-Type: text/html; charset=utf-8

* AN AN AN AN ANANANANAANAANANANANANANANANANNV VVVVE YV VYV

Closing connection #0

Issue another request to this URL: 'https://foreman/api/compute_resources'
* Violate RFC 2616/10.3.2 and switch from POST to GET

* About to connect () to foreman port 443 (#0)

*
w3 Trying foreman... connected

* Connected to foreman (1.2.3.3) port 443 (#0)

* Tnitializing NSS with certpath: sgl:/etc/pki/nssdb
* warning: ignoring value of ssl.verifyhost

* skipping SSL peer certificate verification

* NSS: client certificate not found (nickname not specified)
* SSL connection using TLS_DHE_RSA_WITH_AES_256_CBC_SHA

* Server certificate:

w3 subject: CN=foreman.test

& start date: févr. 14 14:21:23 2016 GMT

w expire date: févr. 13 14:21:23 2021 GMT

&3 common name: foreman.test

& issuer: CN=Puppet CA: foreman.test

*

Server auth using Basic with user 'user'

POST /api/compute_resources HTTP/1.1

Authorization: Basic YXBpYWRtaW46YTEzaUFEbUlOUGE1NVcwcmQ=

User—-Agent: curl/7.19.7 (x86_64-redhat-linux—-gnu) libcurl/7.19.7 NSS/3.15.3 z1ib/1.2.3 libidn/1.
8 libssh2/1.4.2

Host: 10.0.232.59

Content-Type:application/json

Accept:application/json, version=2

HTTP/1.1 500 Internal Server Error

Date: Mon, 15 Feb 2016 15:29:15 GMT

Server: Apache/2.2.15 (Red Hat)

Foreman_version: 1.10.1

Foreman_api_version: 2

Apipie-Checksum: 471e67ed3baf2103277866da41f4c006

X-UA-Compatible: IE=Edge,chrome=1

Cache-Control: no-cache

X-Request-Id: 327b938888c5b99%9a5c82c93a3cldb35¢c

X-Runtime: 0.028014

X-Rack-Cache: invalidate, pass

X-Powered-By: Phusion Passenger 4.0.18

Set-Cookie: request_method=POST; path=/

Set—-Cookie: _session_id=BAh7B0kiD3N1c3Npb25faWQGOgZFRkkiJTk20WQxXxNTgwOTk3Y jkxMzQ3Nzk4MDkzZ jQwZmZ1
MGM4BjsAVEkKi1iC2xVvY2FsZQY7AEZJIIgdlbgY7AEY%$3D--8578d3d2d5137b8cddB8ec04£f1983bbc0584e9168; path=/; Http
Only

Status: 500 Internal Server Error

AN AN ANANANANANANANANANANANANYV V VYV EV VYV

Connection: close

<
<

< Transfer-Encoding: chunked

< Content-Type: application/json; charset=utf-8
<
{

"error": {"message":"ERF42-1330 [Foreman::Exception]: must provide a provider"}

* Closing connection #0

History

#1 - 02/15/2016 11:02 AM - Dominic Cleal
Could you try using the HTTPS URL in your request, not HTTP?

It kind of indicates that curl isn't sending the JSON body (-d) again after being redirected as there's no Content-Length header on the second request.

The APl was changed to require HTTPS to match the Ul in 1.9, see http:/theforeman.org/manuals/1.9/index.html#Releasenotesfor1.9.0 under
Security.

#2 - 02/15/2016 11:03 AM - Dominic Cleal
- Description updated
- Category set to API

- Status changed from New to Feedback

#3 - 02/15/2016 11:08 AM - Anonymous

same result with https and no redirection (without -L flag)
http://theforeman.org/manuals/1.9/index.html#Releasenotesfor1.9.0

# curl -k —-u user:password -H Content-Type:application/json -H Accept:application/json,version=2 -X POST https

://1.2.3.3/api/compute_resources/ —-d '{ "compute_resource": { "name": "Openstack", "provider": "Openstack", "
provider_friendly_name": "OpenStack", "user": "admin", "password": "changeme", "url": "http://1.2.3.4:5000/v2.
0/tokens", "tenant": "admin", "description": "test" }}'
{

"error": {"message":"ERF42-1330 [Foreman::Exception]: must provide a provider"}

#4 - 02/15/2016 12:01 PM - Anonymous

Actually the provider "*Openstack*" must be written "*openstack*" to make it work.
But after the creation, a GET returns "provider="Openstack™"

"

#5 - 02/16/2016 03:47 AM - Dominic Cleal

I'm not sure | can reproduce that, and the error suggests the provider is missing entirely.
Anyway, it's working for you now?

#6 - 02/16/2016 04:04 AM - Anonymous

Yes, it's working. There is just a mismatch between POST (that accepts only 'openstack’) and GET (that returns 'Openstack’).
As you said, | get the same error with 'provider=Openstack’ or without the 'provider' parameter.
Thanks
